Solidworks Macro - Create Centerpoint Arc From VBA Macro

In this post, I tell you about how to create a Centerpoint Arc through Solidworks VBA Macros in a sketch.

The process is almost identical with previous Solidworks Sketch Macros - Create Line post.

In this post, I tell you about CreateArc method from Solidworks SketchManager object.

This method is most updated method, I found in Solidworks API Help.

So use this method if you want to create a new Centerpoint Arc.

Below is the code sample for creating a Centerpoint Arc.

Option Explicit

' Creating variable for Solidworks application
Dim swApp As SldWorks.SldWorks
' Creating variable for Solidworks document
Dim swDoc As SldWorks.ModelDoc2
' Boolean Variable
Dim BoolStatus As Boolean
' Creating variable for Solidworks Sketch Manager
Dim swSketchManager As SldWorks.SketchManager

' Main function of our VBA program
Sub main()

  ' Setting Solidworks variable to Solidworks application
  Set swApp = Application.SldWorks
    
  ' Creating string type variable for storing default part location
  Dim defaultTemplate As String
  ' Setting value of this string type variable to "Default part template"
  defaultTemplate = swApp.GetUserPreferenceStringValue(swUserPreferenceStringValue_e.swDefaultTemplatePart)

  ' Setting Solidworks document to new part document
  Set swDoc = swApp.NewDocument(defaultTemplate, 0, 0, 0)

  ' Selecting Front Plane
  BoolStatus = swDoc.Extension.SelectByID2("Front Plane", "PLANE", 0, 0, 0, False, 0, Nothing, swSelectOption_e.swSelectOptionDefault)
    
  ' Setting Sketch manager for our sketch
  Set swSketchManager = swDoc.SketchManager
    
  ' Inserting a sketch into selected plane
  swSketchManager.InsertSketch True
    
  ' Creating variable name "myCenterpointArc" of "SketchArc" type
  Dim myCenterpointArc As SldWorks.SketchArc
    
  ' Creating a new Centerpoint Arc
  Set myCenterpointArc = swSketchManager.CreateArc(0, 0, 0, 1, 0, 0, -1, 0, 0, 1)
    
  ' De-select the Arc after creation
  swDoc.ClearSelection2 True
    
  ' Zoom to fit screen in Solidworks Window
  swDoc.ViewZoomtofit

End Sub

Understanding the Code

Now let us walk through each line in the above code, and understand the meaning of every line.

Option Explicit

This line forces us to define every variable we are going to use.

For more information please visit Solidworks Macros - Open new Part document post.

' Creating variable for Solidworks application
Dim swApp As SldWorks.SldWorks

In this line, we are creating a variable which we named as swApp and the type of this swApp variable is SldWorks.SldWorks.

' Creating variable for Solidworks document
Dim swDoc As SldWorks.ModelDoc2

In this line, we are creating a variable which we named as swDoc and the type of this swDoc variable is SldWorks.ModelDoc2.

Next is our Sub procedure named main. This procedure hold all the statements (instructions) we give to computer.

' Setting Solidworks variable to Solidworks application
Set swApp = Application.SldWorks

In this line, we are setting the value of our Solidworks variable which we define earlier to Solidworks application.

' Creating string type variable for storing default part location
Dim defaultTemplate As String
' Setting value of this string type variable to "Default part template"
defaultTemplate = swApp.GetUserPreferenceStringValue(swUserPreferenceStringValue_e.swDefaultTemplatePart)

In 1st statement of above example, we are defining a variable of string type and named it as defaultTemplate.

This variable defaultTemplate, hold the location the location of Default Part Template.

In 2nd line of above example. we assign value to our newly define defaultTemplate variable.

We assign the value by using a Method named GetUserPreferenceStringValue(). This method is a part of our main Solidworks variable swApp.

' Setting Solidworks document to new part document
Set swDoc = swApp.NewDocument(defaultTemplate, 0, 0, 0)

In this line, we set the value of our swDoc variable to new document.

For detailed information about these lines please visit Solidworks Macros - Open new Part document post.

' Boolean Variable
Dim BoolStatus As Boolean

' Selecting Front Plane
BoolStatus = swDoc.Extension.SelectByID2("Front Plane", "PLANE", 0, 0, 0, False, 0, Nothing, swSelectOption_e.swSelectOptionDefault)

In 1st line, we create a variable named BoolStatus as Boolean object.

In next line, we select the front plane by using SelectByID2 method from Extension object.

For more information about selection method please visit Solidworks Macros - Selection Methods post.

' Creating variable for Solidworks Sketch Manager
Dim swSketchManager As SldWorks.SketchManager

In above line, we create variable swSketchManager for Solidworks Sketch Manager.

As the name suggested, a Sketch Manager holds variours methods and properties to manage Sketches.

To see methods and properties related to SketchManager object, please visit this page

' Setting Sketch manager for our sketch
Set swSketchManager = swDoc.SketchManager

In above line, we set the sketch manager variable to current document’s sketch manager.

' Inserting a sketch into selected plane
swSketchManager.InsertSketch True

In above line, we use InsertSketch method of SketchManager and give True value.

This method allows us to insert a sketch in selected plane.

' Creating variable name "myCenterpointArc" of "SketchArc" type
Dim myCenterpointArc As SldWorks.SketchArc
    
' Creating a new Centerpoint Arc
Set myCenterpointArc = swSketchManager.CreateArc(0, 0, 0, 1, 0, 0, -1, 0, 0, 1)

In above sample code, we 1st create a variable named myCenterpointArc of type SketchArc.

A SketchArc holds variours methods and properties to manage Arcs.

To see methods and properties related to SketchArc object, please this page of Solidworks API Help

In 2nd line, we set the value of sketch segment variable myCenterpointArc.

We get this value from CreateArc method which is inside the swSketchManager variable.

swSketchManager variable is a type of SketchManager, hence we used CreateArc method from SketchManager.

This CreateArc method takes following parameters as explained:

Xc : X coordinate of the center point, of the arc

Yc : Y coordinate of the center point, of the arc

Zc : Z coordinate of the center point, of the arc

X1 : X coordinate of the start point, of the arc

Y1 : Y coordinate of the start point, of the arc

Z1 : Z coordinate of the start point, of the arc

X2 : X coordinate of the end point, of the arc

Y2 : Y coordinate of the end point, of the arc

Z2 : Z coordinate of the end point, of the arc

Direction : Clockwise or Anti-clockwise (Counter Clockwise) direction

  • +1 : Start point to end point in Anti-clockwise (Counter Clockwise) direction.

  • -1 : Start point to end point in Clockwise direction.

In the above code sample I have used (0, 0, 0) which is at origin as center of Arc.

For start point of the Arc I used (1, 0, 0) which is 1 point distance in X-direction.

For End point of the Arc I used (-1, 0, 0) which is -1 point distance in X-direction.

For Direction, I give +1 value, which means Anti-Clockwise direction.

Below Image show above parameters in Details.

centerpoint-arc-parameter-details

NOTE

It is very important to remember that, when you give distance or any other numeric value in Solidworks API, Solidworks takes that numeric value in Meter only.

Solidworks API does not care about your application’s Unit systems.

For example, I works in ANSI system means “inches” for distance.

But when I used Solidworks API through VBA macros or C#, I have to use converted numeric values.

Because Solidworks API output the distance in Meter only; which is not my requirement.

' De-select the Arc after creation
swDoc.ClearSelection2 True

In the this line of code, we de-select the created Centerpoint Arc.

For de-selecting, we use ClearSelection2 method from our Solidworks document variable swDoc.

' Zoom to fit screen in Solidworks Window
swDoc.ViewZoomtofit

In this last line we use zoom to fit command.

For Zoom to fit, we use ViewZoomtofit method from our Solidworks document variable swDoc.

Hope this post helps you to create Centerpoint Arc in Sketches with Solidworks VB Macros.

For more such tutorials on Solidworks VBA Macros, do come to this blog after sometime.

Till then, Happy learning!!!